/*
 * Copyright 2018 European Commission | CEF eDelivery
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 *
 * You may obtain a copy of the Licence attached in file: LICENCE-EUPL-v1.2.pdf
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and limitations under the Licence.
 */

package eu.europa.ec.edelivery.smp.data.model;

import java.time.LocalDateTime;
import java.util.Objects;

/**
 * Created by gutowpa on 23/01/2018.
 */
public abstract class BaseEntity {


    public abstract Object getId();

    // @Where annotation not working with entities that use inheritance
    // https://hibernate.atlassian.net/browse/HHH-12016
    public abstract LocalDateTime getCreatedOn();
    public abstract LocalDateTime getLastUpdatedOn();

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        BaseEntity dbDomain = (BaseEntity) o;
        return Objects.equals(getId(), dbDomain.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hash(getId());
    }
}
